//LIS in n^2
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;

public class CardsIoanaSlow {
    private static int[] colours; //'E','R','S','W','C'
    private static int[] values;    
    private static int[] plusvalues;
    private static int[] lis;

    private static int N, lislength;
   

    private static int[][] perms = {{0,1,2,3},{0,1,3,2},{0,2,1,3},{0,2,3,1},{0,3,1,2},{0,3,2,1},
                                {1,0,2,3},{1,0,3,2},{1,2,0,3},{1,2,3,0},{1,3,0,2},{1,3,2,0},
                                {2,0,1,3},{2,0,3,1},{2,1,0,3},{2,1,3,0},{2,3,0,1},{2,3,1,0},
                                {3,0,1,2},{3,0,2,1},{3,1,0,2},{3,1,2,0},{3,2,0,1},{3,2,1,0}};        
                                
	private static void read() throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        N = Integer.parseInt(br.readLine());
	
		String[] line = br.readLine().split(" ");
        colours = new int[N];
        values = new int[N];

        for (int i = 0; i<N; ++i) {
            char c = line[i].charAt(0);
            switch (c) {
                case 'E': colours[i] = 0;break;
                case 'R': colours[i] = 1;break;
                case 'S': colours[i] = 2;break;
                case 'W': colours[i] = 3;break;
                case 'C': colours[i] = 4;break;
            }
            values[i] = Integer.parseInt(line[i].substring(1))-1;
        }    
    }

    public static void solve(){
        plusvalues = new int [N];
        lis = new int[N];
        
        int max = 0;
        
        for (int p = 0; p<24;++p) {
            for (int i = 0; i<N; ++i) 
                if (colours[i] == 4) 
                    plusvalues[i] = values[i]+4*N;
                else
                    plusvalues[i] = values[i]+perms[p][colours[i]]*N;
                   
            for (int i = 0; i<N; ++i) {
                lis[i] = 1;
                for (int j = 0; j<i; ++j) 
                    if (plusvalues[j]<plusvalues[i] && lis[j]+1>lis[i])
                        lis[i] = lis[j]+1;
                if (lis[i]>max)
                    max = lis[i];
            }
            
        }
        System.out.println(N-max);            
    }

	public static void main(String[] args) throws IOException {
		read();
        solve();
	}
}

